from django.core.management import BaseCommand
from django.utils.importlib import import_module
from flashcards.test_fixtures import base


class Command(BaseCommand):
    help = 'Apply a test fixture'

    def add_arguments(self, parser):
        parser.add_argument('fixture_names', nargs='+', type=str)

    def handle(self, *args, **options):
        base.apply()
        for fixture in options['fixture_names']:
            module = import_module("flashcards.test_fixtures.%s" % fixture)
            module.apply()