from django.core.management import BaseCommand
from flashcards.models import LecturePeriod, Section
from schedule_scraper.scraper import scrape_sections


class Command(BaseCommand):
    help = 'Imports sections from the specified file'

    def add_arguments(self, parser):
        parser.add_argument('filename', nargs=1, type=str)

    def _to_military(self, time):
        hours, mins = time.split(':')
        if mins[-1] == 'p' and int(hours) < 12:
            hours = str((int(hours)+12)%24)
        time = hours + ':' + mins[:-1]
        return time

    def _parse_time(self, times):
        return map(self._to_military, times.split('-'))

    def handle(self, *args, **options):
        for section in scrape_sections(open(options['filename'][0]).read()):
            # print section
            sec_fields = ('department', 'department_abbreviation', 'course_num', 'instructor', 'course_title')
            section_days = section['section_days'].replace('Tu', 'T').replace('Th', 'H')
            start_time, end_time = self._parse_time(section['section_times'])
            print section['instructor'], start_time, end_time
            sec = Section(quarter='SP15', **{k: v for (k, v) in section.items() if k in sec_fields})
            sec.save()
            for i in section_days:
                week_day = 'SSMTWHF'.index(i)
                lperiod = LecturePeriod(week_day=week_day, start_time=start_time, end_time=end_time)
                lperiod.section = sec
                lperiod.save()
            # print ' '.join(
                # [k + ': ' + v for (k, v) in section.items() if k in sec_fields + ('section_days', 'section_times')])
