from django.core.management import BaseCommand
from flashcards.models import UserFlashcard, User, Now
from django.utils.timezone import now
from datetime import timedelta


class Command(BaseCommand):
    help = 'Notify the users if they have cards to be reviewed'

    def handle(self, *args, **options):
        notify_filter = UserFlashcard.objects.prefetch_related('user').filter(
            next_review__lte=Now()
        ).exclude(
            user__registration_id=None,
            user__last_notified__range=(now()-timedelta(days=1), now())
        ).values_list('user').distinct().all()

        notify_list = map(lambda x: x[0], notify_filter)

        for user in User.objects.filter(pk__in=notify_list):
            print "Notifying user:", user, "with key:", user.registration_id
            user.notify()
