# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models, migrations
import django.core.validators
import flashcards.models


class Migration(migrations.Migration):

    dependencies = [
        ('flashcards', '0001_initial'),
    ]

    operations = [
        migrations.AlterModelOptions(
            name='section',
            options={},
        ),
        migrations.AlterModelManagers(
            name='user',
            managers=[
                ('objects', flashcards.models.EmailOnlyUserManager()),
            ],
        ),
        migrations.AlterField(
            model_name='flashcardreport',
            name='reason',
            field=models.CharField(max_length=255, blank=True),
        ),
        migrations.AlterField(
            model_name='lectureperiod',
            name='week_day',
            field=models.IntegerField(help_text=b'1-indexed day of week, starting at Sunday'),
        ),
        migrations.AlterField(
            model_name='user',
            name='sections',
            field=models.ManyToManyField(help_text=b'The sections which the user is enrolled in', to='flashcards.Section'),
        ),
        migrations.AlterField(
            model_name='user',
            name='username',
            field=models.CharField(help_text='Required. 30 characters or fewer. Letters, digits and @/./+/-/_ only.', max_length=30, error_messages={'unique': 'A user with that username already exists.'}, verbose_name='username', validators=[django.core.validators.RegexValidator('^[\\w.@+-]+$', 'Enter a valid username. This value may contain only letters, numbers and @/./+/-/_ characters.', 'invalid')]),
        ),
    ]
