import serializers
from rest_framework.renderers import JSONRenderer
from ws4redis.publisher import RedisPublisher
from ws4redis.redis_store import RedisMessage


def push_feed_event(event_type, flashcard):
    redis_publisher = RedisPublisher(facility='feed/%d' % flashcard.section_id, broadcast=True)
    redis_publisher.publish_message(RedisMessage(JSONRenderer().render(
        {'event_type': event_type, 'flashcard': serializers.FlashcardSerializer(flashcard).data}
    )))


def push_deck_event(event_type, flashcard, user):
    redis_publisher = RedisPublisher(facility='deck/%d' % flashcard.section_id, users=[user])
    redis_publisher.publish_message(RedisMessage(JSONRenderer().render(
        {'event_type': event_type,
         'flashcard': serializers.FlashcardSerializer(flashcard, context={'user': user}).data}
    )))
