from datetime import time

from flashcards.models import *


def apply():
    User.objects.filter(email='userx@flashy.cards').delete()
    User.objects.filter(email='usery@flashy.cards').delete()
    Section.objects.filter(department_abbreviation='TEST').delete()
    s = Section.objects.create(instructor='Test Prof',
                               course_title='Intro to Testing',
                               course_num="101",
                               quarter="SP15",
                               department="Test Sciences",
                               department_abbreviation='TEST'
                               )
    LecturePeriod.objects.create(section=s, week_day=2, start_time=time(8), end_time=time(9))
    s = Section.objects.create(instructor='Test Prof',
                               course_title='Advanced Testing',
                               course_num="102",
                               quarter="SP15",
                               department="Test Sciences",
                               department_abbreviation='TEST'
                               )
    LecturePeriod.objects.create(section=s, week_day=3, start_time=time(9), end_time=time(10))
    s = Section.objects.create(instructor='Test Prof',
                               course_title='Super Advanced Testing',
                               course_num="103",
                               quarter="SP15",
                               department="Test Sciences",
                               department_abbreviation='TEST'
                               )
    LecturePeriod.objects.create(section=s, week_day=4, start_time=time(10), end_time=time(11))
    u = User.objects.create_user('userx@flashy.cards', password='mynameisuserx', confirmed_email=True)
    u.confirm_email(u.confirmation_key)
    u = User.objects.create_user('usery@flashy.cards', password='mynameisusery', confirmed_email=True)
    u.confirm_email(u.confirmation_key)
