from django.http import Http404
from django.views.static import serve


def serve_with_default(*args, **kwargs):
    """
    Wrap Django's static file serving view. If 404, return a default file
    """
    default_file = kwargs.get('default_file', 'index.html')
    del kwargs['default_file']
    try:
        return serve(*args, **kwargs)
    except Http404:
        kwargs['path'] = default_file
        return serve(*args, **kwargs)