from sys import argv

from bs4 import BeautifulSoup


def scrape_sections(html):
    soup = BeautifulSoup(html)

    for c in soup.find_all(class_="nonenrtxt") + soup.find_all(class_="sectxt"):
        flat = c.prettify().replace('\n', '')
        if '<span id="insTyp" title="Lecture">' not in flat and '<span id="insTyp" title="Seminar">' not in flat:
            continue
        fields = map(lambda x: x.strip(' \t\n'), c.strings)
        print fields
        if 'Cancelled' in fields or 'TBA' in fields: continue
        index = 6
        if ' '.join(fields).split()[0].isdigit():
            index = 7
        prof = ' '.join(' '.join(fields).split()[index:])
        if prof.strip() == '':
            prof = 'N/A'
        coursenum = None
        course_title = None
        dept = None
        for p in c.previous_siblings:
            p = unicode(p)
            if "crsheader" in p and not coursenum:
                coursenum = list(BeautifulSoup(p).find_all(class_="crsheader")[1].strings)[0].strip()
                course_title = ' '.join(list(BeautifulSoup(p).find_all(class_="crsheader")[2].strings)[0].split()[:-3])
            elif "centeralign" in p and not dept:
                dept = BeautifulSoup(p).find(class_="centeralign").contents[0].strip()
                break
        assert dept and coursenum and course_title
        abbr = dept.split('(')[-1].rstrip(')').strip()
        dept = dept.split('(')[0].strip()

        field_names = ('department',
                       'department_abbreviation',
                       'course_num',
                       'course_title',
                       'instructor',
                       'section_id',
                       'section_type',
                       'section_num',
                       'section_days',
                       'section_times',
                       'building',
                       'room_num')
        fields = [dept, abbr, coursenum, course_title, prof] + [y for x, y in enumerate(fields) if
                                                                x in (3, 6, 9, 11, 13, 15, 17)]
        yield dict(zip(field_names, fields))


def main():
    if len(argv) < 2:
        print "Filename required"
        exit(1)
    filename = argv[1]
    out = open('dump.json', 'w')
    for section in scrape_sections(open(filename).read()):
        out.write(str(section) + '\n')


if __name__ == '__main__':
    main()
